<template>
    <div class="order_block" >
        <Loading :loading="isLoading" v-if="isLoading"></Loading>
        <div v-if="show_actions">
            <table width="100%" border="0" cellspacing="0" cellpadding="0" v-if="(!isLoading) && cart_data!=null">
            <thead>
                <tr>
                  <th width="20%">Product</th>
                  <th>Price</th>
                  <th>Quantity</th>
                </tr>
            </thead>
            <tbody  v-if="cart_data.cart_details.length>0">
                <tr v-for="(detail,i) in cart_data.cart_details" :key="i">
              <td><div class="order_product_details">
                  <div class="order_product_details_close"> <a href="javascript:;" class="order_close_icon" @click="onClickDelete(detail)"></a></div>
                  <div class="order_product_details_img" ><img v-if="detail.product.file_upload.length>0" :src="`${options.storage_root}/`+detail.product.file_upload[0].upload.uploaded_path" :title="(detail.product.file_upload[0].title!=null) ? detail.product.file_upload[0].title : detail.product_title" :alt="(detail.product.file_upload[0].alt_text!=null) ? detail.product.file_upload[0].alt_text : detail.product_title"/>
                  <img :alt="detail.product_title" v-else src="/images/no-img.png">
                  </div>
                  <div class="order_product_details_title">
                    <h2><a :href="buildProductUrl(detail.product)"  @click="openFries(detail.product)">{{ detail.product_title }}</a><span v-if="detail.fast_delivery"> (Fast Delivery)</span></h2>
                    <span v-if="detail.not_available">(This product is not available now)</span>
                    <p class="mb-0 pb-0">Price  : ${{ (detail.product_price*1).toFixed(2) }} <span v-if="detail.rent_period!=null">
                        {{ detail.rent_period.name }}
                    </span>
                    <span v-else>
                        {{ detail.custom_rent_period }}
                    </span>
                    <span v-if="detail.rent_term!=null">
                        {{ detail.rent_term.name }}
                    </span>
                    <span v-else>
                        {{ detail.custom_rent_term }}
                    </span></p>
                    <div class="radio_text" v-if="detail.pickup_available && detail.cartage_available">
                        <v-radio-group v-model="detail.pickup" @change="changePrice()">
                          <v-radio
                            :label="`Delivery - $${(Boolean(detail.product.cartage_override)) ? (Number(detail.product.cartage)*1).toFixed(2) : (Number(detail.product.default_category.cartage)*1).toFixed(2)}`"
                            :value="0"
                          ></v-radio>
                          <v-radio
                            :label="`Collect in Store $0`"
                            :value="1"
                          ></v-radio>
                        </v-radio-group>
                    </div>
                    <div v-else-if="detail.cartage_available">
                        <b>Delivery - ${{ (Boolean(detail.product.cartage_override)) ? (Number(detail.product.cartage)*1).toFixed(2) : (Number(detail.product.default_category.cartage)*1).toFixed(2) }}</b>
                    </div>
                  </div>
                </div>
                </td>
              <td class="d-none d-lg-block"><div class="order_product_details_price">${{ (detail.product_price*detail.qty*1).toFixed(2) }}</div></td>
              <td>
              <div class="order_product_details_qty_block">
				<div class="order_product_details_price d-lg-none">Price  : ${{ (detail.product_price*detail.qty*1).toFixed(2) }}</div>
                  <div class="order_product_details_qty" ><span class="d-inline-block d-lg-none">Quantity  :</span> &nbsp;
                    
                    <button type="button" id="sub" class="sub" @click="minusQty(detail)">-</button>
                    <input class="count" type="text"  v-model="detail.qty" min="1" max="100" />
                    <button type="button" id="add" class="add" @click="plusQty(detail)">+</button>
                  </div>
                  
                </div>
                </td>
                </tr>
            </tbody>
            <tbody v-else>
                <tr>
                    <td colspan="3"><b>No Products found</b></td>
                </tr>
            </tbody>
        </table>
        </div>
        <div v-else>
            <table width="100%" border="0" cellspacing="0" cellpadding="0" v-if="(!isLoading) && cart_data!=null">
            <thead>
                <tr>
                  <th width="20%">Product</th>
                  <th>Price</th>
                  <th>Quantity</th>
                </tr>
            </thead>
            <tbody  v-if="cart_data.cart_details.length>0">
                <tr v-for="(detail,i) in cart_data.cart_details" :key="i">
              <td><div class="order_product_details">
                  <div class="order_product_details_img" ><img v-if="detail.product.file_upload.length>0" :src="`${options.storage_root}/`+detail.product.file_upload[0].upload.uploaded_path"  :title="(detail.product.file_upload[0].title!=null) ? detail.product.file_upload[0].title : detail.product_title" :alt="(detail.product.file_upload[0].alt_text!=null) ? detail.product.file_upload[0].alt_text : detail.product_title"/>
                  <img :alt="detail.product_title" v-else src="/images/no-img.png">
                  </div>
                  <div class="order_product_details_title">
                    <h2><a :href="buildProductUrl(detail.product)"  @click="openFries(detail.product)">{{ detail.product_title }}<span v-if="detail.fast_delivery">(Fast Delivery)</span></a></h2>
                    <span v-if="detail.not_available">(This product is not available now)</span>
                    <p class="mb-0 pb-0">Price  : ${{ (detail.product_price*1).toFixed(2) }} <span v-if="detail.rent_period!=null">
                        {{ detail.rent_period.name }}
                    </span>
                    <span v-else>
                        {{ detail.custom_rent_period }}
                    </span>
                    <span v-if="detail.rent_term!=null">
                        {{ detail.rent_term.name }}
                    </span>
                    <span v-else>
                        {{ detail.custom_rent_term }}
                    </span></p>
                    <div v-if="detail.pickup">
                        <b>Pickup</b>
                    </div>
                    <div v-else-if="detail.cartage_available">
                        <b>Delivery - ${{ (Number(detail.cartage_fee)*1).toFixed(2) }}</b>
                    </div>
                  </div>
                </div>
                </td>
              <td class="d-none d-lg-block"><div class="order_product_details_price">${{ (detail.product_price*detail.qty*1).toFixed(2) }}</div></td>
              <td>
              <div class="order_product_details_qty_block">
				<div class="order_product_details_price d-lg-none">Price  : ${{ (detail.product_price*detail.qty*1).toFixed(2) }}</div>
                  <div class="order_product_details_qty" >
                      {{ detail.qty }}
                  </div>
                </div>
                
                </td>
                </tr>
            </tbody>
            <tbody v-else>
                <tr>
                    <td colspan="3"><b>No Products found</b></td>
                </tr>
            </tbody>
        </table>
        </div>
        <v-app class="vue-front-end-fixed">
            <location-confirmation ref="deletion" 
              width="600"
              :confirm_button_color="'#FFFF00'"
              :cancel_button_color="'grey'"
              :show_close="true"
              msg="Do you want to delete this from cart?" 
              @confirm="deleteCartDetail"
              ></location-confirmation>
        </v-app>
    </div>
</template>
<script>
import options from '~/assets/options.js';
import LocationConfirmation from '~/components/front-end/LocationConfirmation.vue';
import Loading from '../Loading.vue';
export default {
    components : { LocationConfirmation, Loading },
    props : {
        cart_data : {
            default : null
        },
        show_actions : {
            default : true,
        }
    },
    mounted() {
    },
    data() {
        return {
            options     :options,
            detail_id : null,
            location_name : this.$store.state.front_end_data.location_name,
            isLoading : false,
            current_detail  : null,
            domain          :this.$store.state.front_end_data.domain,
        }
    },
    methods : {
        setLoading(status) {
            this.isLoading = status;
        },
        async minusQty(detail) {
            if(Number(detail.qty)==1) {
                this.onClickDelete(detail);
            }
            else {
                detail.qty = detail.qty-1;
                this.$emit('update-qty');
            }
        },
        async plusQty(detail) {
            detail.qty = detail.qty+1; 
            this.$emit('update-qty');
        },
        buildProductUrl(product) {
            let parent_category = (product.default_category.parent_category!=null) ? product.default_category.parent_category.link_rewrite+'/' : "";
            let route = '/'+this.location_name+'/'+parent_category+product.default_category.link_rewrite+'/'+product.link_rewrite;
            if(product.show_on_catelogue) {
                return route;
            }
            return 'javascript:;';
        },
        openFries(product) {
            if(!product.show_on_catelogue) {
                this.$refs.view_model.openModel(product);
            }
        },
        onClickDelete(detail) {
            this.detail_id = detail.id;
            this.current_detail = detail;
            this.$refs.deletion.view = true;
        },
        changePrice() {
            this.$emit('update-qty');
        },
        deleteCartDetail() {
            let cart_detail = [{
                item_name       : this.current_detail.product.name,
                item_id         : this.current_detail.product.id,
                price           : this.current_detail.product_price,
                quantity        : this.current_detail.qty,
                variant_id      : this.current_detail.selected_price_type,
                item_category   : (this.current_detail.product.default_category!=null) ? this.current_detail.product.default_category.name : ""
            }]
            productSelection(cart_detail,'remove_from_cart');
            this.$axios.$delete('/api/cart/'+this.detail_id)
            .then(async (resp)=>{
                await this.$store.dispatch('getLayoutData');
                this.$emit('get-cart');
                this.current_detail = null;
                this.$refs.deletion.view = false;
            })
        },
    }
}
</script>